;
;			Header File for SAY Version 1.82
;
;		  Copyright (C) 1993,1995 NOWSOFT , YUTAKA AOKI
;
;------------------------------------------------------------------------------
SAY_SOFTINTNO	equ	041h
SAY_VERSION	equ	182	;BootMes ̃o|WɕύX邱
DATA_VERSION	equ	2
;------------------------------------------------------------------------------
WAITPORT	equ	5fh
EOI		equ	20h
;------------------------------------------------------------------------------
SAY_SND_INIT		equ	0
SAY_ALL_STOP		equ	1
SAY_ALL_CONT		equ	2
SAY_SND_START		equ	3
SAY_SND_FILE_LOAD	equ	4
SAY_SND_STOP		equ	5
SAY_SND_CONT		equ	6
SAY_SND_RESTART		equ	7
SAY_SND_FREE		equ	8
SAY_SET_PART_MASK	equ	9
SAY_SET_EXT_TEMPO	equ	10
SAY_OFF_EXT_TEMPO	equ	11
SAY_SET_TEMPO		equ	12
SAY_SET_VOL		equ	13
SAY_OPNA_WRITE		equ	14
SAY_OPNB_WRITE		equ	15
SAY_OPNA_READ		equ	16
SAY_FADE_START		equ	17
SAY_FADE_STOP		equ	18
SAY_FADE_CLEAR		equ	19
SAY_FADE_WAIT		equ	20
SAY_TASK_RESERVE	equ	21
SAY_TASK_REMOVE		equ	22
SAY_TASK_SEARCH		equ	23
SAY_TASK_ALL_CLR	equ	24
SAY_TASK_ON		equ	25
SAY_TASK_OFF		equ	26
SAY_PCM_RATE_SET	equ	27
SAY_OR_F_CHANGE_FLG	equ	28
SAY_OR_F_CHANGE_FLGS	equ	29
SAY_OR_R_CHANGE_FLG	equ	30
SAY_OR_R_CHANGE_FLGS	equ	31
SAY_SET_FADE_LEVEL	equ	32
;------------------------------------------------------------------------------
S_ER_OK			equ	0
S_ER_ILL_FUNC		equ	1
S_ER_BUF_OVERFLOW	equ	2
S_ER_TOO_MANY_SNDFILE	equ	3
S_ER_SND_FILE_NOT_FOUND	equ	4
S_ER_SND_FILE_TOO_LARGE	equ	5
S_ER_SND_FILE_VER_ERR	equ	6
S_ER_PCM_FILE_NOT_FOUND	equ	7
S_ER_PCM_FILE_TOO_LARGE	equ	8
S_ER_PCM_FILE_DENIED	equ	9
S_ER_PCM_EMS_OVERFLOW	equ	10
S_ER_NOT_SND_HND	equ	11
S_ER_NOT_TASK_HND	equ	12
;------------------------------------------------------------------------------
ST_END		equ	0
ST_ON		equ	1
ST_ERR		equ	2
;------------------------------------------------------------------------------
TOperator	struc
		
FR30		db	?
FR40		db	?
FR50		db	?
FR60		db	?
FR70		db	?
FR80		db	?
		
TOperator	ends
		
TFMEnvelope	struc
		
FRB0		db	?
Operator	TOperator 4 dup ( <> )
		
TFMEnvelope	ends
;------------------------------------------------------------------------------
TPSGEnvelope	struc
		
PSv		db	?
PAr		db	?
PDr		db	?
PSl		db	?
PSr		db	?
PRr		db	?
		
TPSGEnvelope	ends
;------------------------------------------------------------------------------
TPCMEnvelope2	struc
		
CSv		db	?
CAr		db	?
CDr		db	?
CSl		db	?
CSr		db	?
CRr		db	?
		
TPCMEnvelope2	ends
;------------------------------------------------------------------------------
TTLFO		struc
		
TLFOFlg		db	0
		
TLFOKind	db	0
TLFOInterval	db	0
TLFOStep	dw	0
TLFODelay	db	0	;Delay
TLFODepth	db	0	;Depth
		
TLFOUpDown	db	0
TLFOInterval2	db	0
TLFOStep2	dd	0
TLFODelay2	db	0	;Delay Counter
TLFODepth2	db	0	;Depth Counter
		
TTLFO		ends
;------------------------------------------------------------------------------
TVLFO		struc
		
VLFOFlg		db	0
		
VLFOKind	db	0
VLFOInterval	db	0
VLFOStep	dw	0	;Step/256
VLFODelay	db	0	;Delay
VLFODepth	db	0	;Depth
		
VLFOUpDown	db	0
VLFOInterval2	db	0
VLFOSwing	dw	0	;Swing/256
VLFODelay2	db	0	;Delay Counter
VLFODepth2	db	0	;Depth Counter
		
TVLFO		ends
;------------------------------------------------------------------------------
TFMStatus	struc
		
FFlg		db	0
		
FTop		dw	0
FPoi		dw	0
FStackBottom	dw	0
FStack		dw	0
		
FKeyOnFlg	db	0
		
FAllTime	db	0
FOnTime		db	0
		
FQFlg		db	0
FQ		dw	0	;Point Number(0-2)
		
FCurLen		db	0
		
FTone1		dw	0	;0`288 (12*3*8)
FOct1		db	0
FTone2		dw	0	;0`288 (12*3*8)
		
FFreq		dd	0
FFreq1		dd	0
FFreq2		dd	0
		
FPitchFlg	db	0	;bit 0:Off/On,1:Up/Down,2:Add/Mult,3:LastFlg
FPitchDelay	db	0
FPitchInterval	db	0
FPitchInterval2	db	0
FPitchStep	dd	0
		
FTune		dw	0
FDt		db	0
		
FLFOMode	db	0
		
FTLFO		TTLFO	3 dup ( <> )
FVLFO		TVLFO	<>
		
FTieFlg		db	0
		
FVolume		db	0	;Add this to Tl
		
FChangeFlg	db	0
		
FFMEnv		dw	0
FLR_AMS_PMS	db	0
		
TFMStatus	ends
;------------------------------------------------------------------------------
TPSGStatus	struc
		
PFlg		db	0
		
PTop		dw	0
PPoi		dw	0
PStackBottom	dw	0
PStack		dw	0
		
PKeyOnFlg	db	0
		
PAllTime	db	0
POnTime		db	0
		
PQFlg		db	0
PQ		dw	0	;Point Number(0-2)
		
PCurLen		db	0
		
PTone1		dw	0
POct1		db	0
PTone2		dw	0
		
PFreq		dd	0
PFreq1		dd	0
PFreq2		dd	0
		
PPitchFlg	db	0
PPitchDelay	db	0
PPitchInterval	db	0
PPitchInterval2	db	0
PPitchStep	dd	0
		
PTune		dw	0
PDt		db	0
		
PLFOMode	db	0
		
PTLFO		TTLFO	3 dup ( <> )
PVLFO		TVLFO	<>
		
PTieFlg		db	0
		
PMaxLevel	db	0	;Integer Number(0-15)
		
PPSGEnv		dw	0
		
PLevel		db	0	;Integer Number(0-15)
PEnvFlg		db	0	
PLogicalLevel	db	0	;0-255
		
PAutoMaxLogicalLevelFlg	db	0
PMaxLogicalLevel	db	0
		
PNoiseMode	db	0
		
TPSGStatus	ends
;------------------------------------------------------------------------------
TPCMStatus	struc
		
CFlg		db	0
		
CTop		dw	0
CPoi		dw	0
CStackBottom	dw	0
CStack		dw	0
		
CKeyOnFlg	db	0
		
CAllTime	db	0
COnTime		db	0
		
CQFlg		db	0
CQ		dw	0	;Point Number(0-2)
		
CCurLen		db	0
		
CTone1		dw	0
COct1		db	0
CTone2		dw	0
		
CFreq		dd	0
CFreq1		dd	0
CFreq2		dd	0
		
CPitchFlg	db	0
CPitchDelay	db	0
CFPitchInterval	db	0
CPitchInterval2	db	0
CPitchStep	dd	0
		
CTune		dw	0
CDt		db	0
		
CLFOMode	db	0
		
CTLFO		TTLFO	3 dup ( <> )
CVLFO		TVLFO	<>
		
CTieFlg		db	0
		
CMaxVolume	db	0
		
CPCMEnv2	dw	0
		
CVolume		db	0
CEnvFlg		db	0
CLogicalLevel	db	0
		
CAutoMaxLogicalLevelFlg	db	0
CMaxLogicalLevel	db	0
		
CPCMEnv1Off	dw	0
CPCMEnv1Page	dw	0
		
CPCMPos		dd	0
		
TPCMStatus	ends
;------------------------------------------------------------------------------
TRythmStatus	struc
		
RFlg		db	0
		
RTop		dw	0
RPoi		dw	0
RStackBottom	dw	0
RStack		dw	0
		
RKeyOnFlg	db	0
		
RAllTime	db	0
ROnTime		db	0
		
RQFlg		db	0
RQ		dw	0	;Point Number(0-2)
		
RCurLen		db	0
		
RInstrument	db	0
		
RChangeFlg	db	0
		
RLR_ILevel	db	6 dup (?)
		
RVolume		db	0
		
TRythmStatus	ends
;------------------------------------------------------------------------------
TSndInfo	struc
		
PartMaskFlg	dw	0
CurrentPart	dw	0
		
CurrentPort	db	0		;0 : ?88H,?8AH , 4 : ?8CH,?8EH
		
FMWeek		db	32		;
PSGWeek		db	0		;
RhythmWeek	db	0		;
PCMWeek		db	0		;
		
MonoFlg		db	0		;0:XeIB
					;1:IɃmɂB
		
ExtTimerFlg	db	0
SkipTempo	db	240
		
Volume		db	0
		db	0		;word ANZXp Dummy
		
SndDataSu	db	0		;̃TEhf[^i0-32j
SndDataSeg	dw	32 dup (0)	;TEhf[^̃[U[nh
		
SndPartFlg	db	26 dup (255)	;ep[gŌɃANZXȂ̗D
					;
SndLastSeg	dw	26 dup (0)	;Ōɖ炵Ȃ̃[U[nh
		
IDCnt		dw	0		;ID JE^B풓AȂ[h
					;xɃJEgBȂ̂قڊ
					;SȂhcԍƂȂB
		
TSndInfo	ends
;------------------------------------------------------------------------------
TDrvInfo	struc
		
SAYTitle	db	"SndDrvSAY"
SAYVersion	db	SAY_VERSION	;o[W͗]CɂĂdB
DataVersion	db	DATA_VERSION
		
SAYPSP		dw	?	;hCôoroZOg
		
IntFlg		db	0	;0 Ȃ犄[`Ɋ荞łȂB
		
LocalStackUse	db	0	;0	: 荞ݒłȂ
				;0 ȊO	: |JX^bN̎gpvO
		
TimerIntService	db	0	;0 : 荞ݒłȂ , 1 : 荞ݒł
TimerIntAccess	db	0	;^C}|荞݂0ffh܂
		
OPNIntNo	db	?
OPNIntVect	dd	?
Int28Vect	dd	?
		
I8259CW0	dw	?
I8259CW1	dw	?
I8259MaskBit	db	?
		
LastSoftIntVect	dd	?
LastOPNIntVect	dd	?
LastInt28Vect	dd	?
		
SndInfoPoi	dd	?
		
SndBufSeg	dw	?
SndBufSize	dw	2000h/16	;Paragrph Size ( Default 8 KBytes )
LocalStackSeg	dw	?
LocalStackSize	dw	300		;oCg
		
GaijiLoadFlg	db	0	;O[h΂PɂȂB
		
OPNKind		db	0	;0 : YM-2203 , 1 : YM-2608
PCMKind		db	0	;Bit 0 : 1 : WU{[h
				;Bit 6 : 1 : -p w肩Aobl gps\
				;Bit 7 : 1 : -p w肩Aobl gp\
		
OPNPortNo	dw	0188h
		
DInt28Flg	db	0
		
PCMBufSeg	dw	0	;0 : PCM obt@mۂĂȂB
		
PCMUseCnt	dw	0	;0 : PCM gpA0 ȊO : PCM gpp[g
		
PCMRate		db	3	;0:44.10,1:33.08,2:22.05,3:16.54
				;4:11.03,5:8.27,6:5.52,7:4.13
		
FIFOLeft0	db	24	;44.10 KHz ̒l
FIFOLeft	db	?	;ۂ̒l
		
PCMSendBytes	dw	128
		
EMSExistFlg	db	0	;0 : EMS gpsA1 : EMS gp\
EMSHandle	dw	0	;0 ȊO : EMS nhA0 : nh
EMSPageMax	dw	0	;mۂ _y[W
		
EMSRestTopOff	dw	0	;EMS ̋󂫗̈̐擪ItZbgAhX
EMSRestTopPage	dw	0	;EMS ̋󂫗̈̐擪y[Wmn
		
LinkJumpAddr	dd	0	;n[hEFA̍Ō̃tbNAhX
		
ErrNo		dw	0
		
TDrvInfo	ends
;------------------------------------------------------------------------------
TMCB		struc
		
MCBFlg		db	?
MCBSize		dw	?	;Paragraph Size
		
;		MCBFlgɂ
;		00h : gp̃ubN , 0ffh : Ō̃ubNiTCY͂Oj
;		01h : TEhf|^ , 02h : 풓vO
;		03h : oblobt@ , 04h : ̑̃f|^
;
TMCB		ends
;------------------------------------------------------------------------------
TUserInfo	struc
		
		TMCB <>
		
;
;	MixFlg
;	Bit 0 = 0 : ^A1 : ~^
;	    1 = 0 : 풓wA1 : I
;	    2 = 0 : ĊJ^ , 1 : ~^ iBit 0 = 1 ̎j
;	    3 = 0 : [hAɂ͉tȂB, 1 : ɉtB
;           -------
;	    7 = 0 : t~ԁiŖBjA1 : t
;
		
MixFlg		db	?	;ԂɒӁII
PriorityOrder	db	?	;D揇
		
SndID		dw	?	;Ȃ̂hcԍB܂ꂽԂB
				;ۂǂ̎ȂA̒lŋȂS
				;ʉ\łB[U[nh́Apro
				;bt@̃ZOgAhXȂ̂ŁAÂȂ
				;AVȂ[hƁAAh
				;XɂȂ邱ƂL邪ASndID ͂̏ꍇł
				;lɂȂB
		
IntAccess	db	?	;ȂɃ^C}ANZXƁA0ffh ɂȂB
		
MainLoopCount	db	?	;C[v̎c
MainLoopFade	db	?	;tJnɎw肵tF[hAEgXs[h
		
WaitFlg		dw	?
		
UserTempo	db	?	;̋Ȃ̃e|
NextPeriod	dw	?	;̊܂ł̎ t255 ̎ԂP
		
ActivePart	db	?	;t̑Sp[giOȂSp[gtI
				;ԂłBiIɂ͏dĂjj
PCMActivePart	db	?	;t̂oblp[g

FadeCount0	db	?	;tF[hAEgXs[h
FadeCount	db	?	;0 ȊO : tF[hAEgA0 : ʏ
				;FadeCount!=0 ŃtF[hAEg𔻒f邪A
				;FadeCount0 ̒lAFadeCount ɑ̂
				;XӂKvB

FadeLevel	db	?	;ʌ
		db	?	;Dummy
		
ComSyncFlg	db	?	;RgR}hŁA0ffh ɂȂB
				;ŏA0ffh B
ExtSyncFlg	db	?	;OVNR}h 0ffh ɂȂB
		
ToneNoise	db	?
Noise		db	?
		
EnvDataSu	db	?
FMPartSu	db	?
PSGPartSu	db	?
RythmPartSu	db	?
PCMPartSu	db	?
TailDataSu	db	?
		
TailDataTop	dw	?
PCMEnv1Su	db	?	;EnvDataSu>=3 ݈̎̂Ӗ
		
LenTabTop	dw	?	;offset
FMEnvTop	dw	?	;offset
PSGEnvTop	dw	?	;offset
PCMEnv1Top	dw	?	;offset
PCMEnv2Top	dw	?	;offset
		
FMStTop		dw	?	;offset
PSGStTop	dw	?	;offset
RythmStTop	dw	?	;offset
PCMStTop	dw	?	;offset
		
TUserInfo	ends
;------------------------------------------------------------------------------
TSAYHeader	struc
		
HDataVersion	db	?
HDataFlg	db	?
		
HEnvDataSu	db	0
HFMDataSu	db	0
HPSGDataSu	db	0
HRythmDataSu	db	0
HPCMDataSu	db	0
HTailDataSu	db	0
		
HAddr		dw	(5+6+3+1+16+1) dup (?)
		dw	?		;Dummy
		
TSAYHeader	ends
;------------------------------------------------------------------------------
TInt28Header	struc
		
		TMCB <>
		
Int28Flg	dw	?
		
;
;	Int28Flgɂ
;	Bit 0 = 0 : ̃^XN͒~A1 : ̃^XN͓쒆
;
		
TaskName	db	'        '
		
Int28Init	dw	?	;Initialize Routine
Int28Remove	dw	?	;Remove Routine
Int28Main	dw	?	;int 28h Routine
		
TInt28Header	ends
;------------------------------------------------------------------------------
TDataPack	struc
		
DataPackPoi	dd	?
DataPackBytes	dw	?
		
TDataPack	ends
		
TStartInfo	struc
		
STEnvDataSu	db	0
STFMDataSu	db	0
STPSGDataSu	db	0
STRythmDataSu	db	0
STPCMDataSu	db	0
STTailDataSu	db	0
		
STDataPack	TDataPack (5+6+3+1+16+1) dup (<>)
		
TStartInfo	ends
